<template>
  <div class="app-container">
    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-select v-model="table.getdataListParm.parammaps.usetype" placeholder="操作类型" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="item in operationTypeList" :key="item.id" :label="item.label" :value="item.value" />
      </el-select>
      <el-autocomplete v-model="table.getdataListParm.parammaps.feedname" value-key="feedname" class="inline-input filter-item" :fetch-suggestions="tableFeedNameSearch" placeholder="饲料名称" style="width:250px" @select="handleSelectTableFeedName">
        <template slot-scope="{ item }">
          <span>{{ item.feedname }}</span>
        </template>
      </el-autocomplete>
      <el-select v-model="table.getdataListParm.parammaps.cowclassid" filterable placeholder="请选择牲畜类别" class="filter-item" style="width: 150px;" clearable>
        <el-option v-for="item in livestockList" :key="item.id" :label="item.mixname" :value="item.id" />
      </el-select>
      <el-button class="successBorder" @click="handleSearch">查询</el-button>
      <el-button class="successBorder" @click="handleRefresh">重置</el-button>
    </div>
    <div class="operation">
      <el-button v-if="isRoleEdit" class="success" icon="el-icon-plus" @click="handleCreate">新增</el-button>
      <el-upload style="float: right;" :headers="headers" :data="uploadData" :action="uploadExcelUrl" :show-file-list="false" :before-upload="beforeImport" :on-success="handleImportSuccess">
        <el-button v-if="isRoleEdit" class="import" icon="el-icon-download" style="float: right;">导入</el-button>
      </el-upload>
      <el-dropdown style="float: right;margin-right: 10px;">
        <el-button class="export" icon="el-icon-upload2">导出</el-button>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item @click.native="handleExport(1)">导出模板</el-dropdown-item>
          <el-dropdown-item @click.native="handleExport(2)">导出数据</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>
    <div class="table">
      <el-table
        :key="table.tableKey"
        v-loading="table.listLoading"
        element-loading-text="给我一点时间"
        :data="table.list"
        border
        fit
        highlight-current-row
        style="width: 100%;"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
        :max-height="myHeight"
      >
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="出库日期" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.usedate }}</span>
          </template>
        </el-table-column>
        <el-table-column label="牲畜类别" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.cowclass }}</span>
          </template>
        </el-table-column>
        <el-table-column label="饲料名称" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.feedname }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作重量（kg）" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.operateweight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作类型" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.usetype }}</span>
          </template>
        </el-table-column>
        <el-table-column label="备注" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.remark }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作人" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.createemp }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="80" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button  v-if="isRoleEdit" class="miniSuccess" icon="el-icon-edit-outline" @click="handleUpdate(row)" />
            <span v-if="isRoleEdit" class="centerSpan">|</span>
            <el-button v-if="isRoleEdit" icon="el-icon-delete" class="miniDanger" @click="handleRowDelete(row)" />
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="getList" />
    </div>

    <!-- 新增/编辑 -->
    <el-dialog :fullscreen="dialogFull" :visible.sync="create.dialogFormVisible" :close-on-click-modal="false" width="80%">
      <template slot="title">
        <div class="avue-crud__dialog__header">
          <span class="el-dialog__title">
            <span style="display:inline-block;width:3px;height:20px;margin-right:5px; float: left;margin-top:2px" />
            {{ textMap[create.dialogStatus] }}
          </span>
          <div class="avue-crud__dialog__menu" @click="dialogFull? dialogFull=false: dialogFull=true">
            <svg-icon v-if="dialogFull" icon-class="exit-fullscreen" />
            <svg-icon v-else icon-class="fullscreen" />
          </div>
        </div>
      </template>
      <div class="app-add">
        <el-form ref="createTemp" :rules="create.rules" :model="create.createTemp" label-position="right" label-width="150px" style="width: 90%;height:300px;margin:0 auto 50px">
          <el-row>
            <el-col :span="12">
              <el-form-item label="操作类型：" prop="usetype">
                <el-select v-model="create.createTemp.usetype" placeholder="操作类型" class="filter-item" style="width: 100%;"  @change="changeUsetype">
                  <el-option v-for="item in operationTypeList" :key="item.id" :label="item.label" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item label="出库日期：" prop="usedate">
                <el-date-picker v-model="create.createTemp.usedate" :picker-options="create.pickerOptions1" :clearable="false" class="filter-item" format="yyyy-MM-dd" value-format="yyyy-MM-dd" style="width: 100%;" type="datetime" placeholder="出库日期" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="12">
              <el-form-item label="饲料名称：" prop="feedname">
                <el-autocomplete v-model="create.createTemp.feedname" value-key="feedname" class="inline-input" :fetch-suggestions="feedNameSearch" placeholder="请选择饲料名称" style="width:100%" @select="handleSelectFeedName" @blur="blurFeedName">
                  <template slot-scope="{ item }">
                    <span>{{ item.feedname }}</span>
                  </template>
                </el-autocomplete>
              </el-form-item>
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item label="牲畜类别：" prop="cowclassid">
                <el-input v-if="create.dialogStatus==='see'" ref="cowclass" v-model="create.createTemp.cowclass" disabled class="filter-item" placeholder="请选择牲畜类别" type="text" disabled />
                <el-select v-else v-model="create.createTemp.cowclassid" filterable placeholder="请选择牲畜类别" class="filter-item" style="width: 100%;" :disabled="create.dialogStatus==='see' || create.createTemp.usetype=='损耗'" @change="changeLivestock">
                  <el-option v-for="item in livestockList" :key="item.id" :label="item.mixname" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="12">
              <el-form-item label="库存重量（kg）：" prop="repertoryweight">
                <el-input ref="repertoryweight" v-model="create.createTemp.repertoryweight" class="filter-item" placeholder="最多两位小数" type="text" disabled />
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item label="操作重量（kg）：" prop="operateweight">
                <el-input ref="operateweight" v-model="create.createTemp.operateweight" class="filter-item" placeholder="最多两位小数" type="text" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="12">
              <el-form-item label="备注：" prop="remark">
                <el-input ref="remark" v-model="create.createTemp.remark" class="filter-item" placeholder="1-255字符" type="text" />
              </el-form-item>
            </el-col>
            <el-col :span="12">
              <el-form-item label="操作人：" prop="createemp">
                <el-input ref="createemp" v-model="create.createTemp.createemp" class="filter-item" placeholder="1-255字符" type="text" disabled />
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button v-if="create.dialogStatus==='create' || create.dialogStatus==='update'" class="cancelClose" @click="create.dialogFormVisible = false;getList();">关闭</el-button>
          <el-button v-if="create.dialogStatus==='create' || create.dialogStatus==='update'" class="save" :disabled="isokDisable" @click="create.dialogStatus==='create'?createData():updateData()">确认</el-button>
        </div>
      </div>
    </el-dialog>

  </div>

</template>

<script>
import { GetDataByName, GetDataByNames, checkButtons, ExecDataByConfig, failproccess } from '@/api/common'
import Pagination from '@/components/Pagination'
import Cookies from 'js-cookie'
import { parseTime, json2excel } from '@/utils/index.js'
import axios from 'axios'
import { getToken } from '@/utils/auth'
import { MessageBox } from 'element-ui'
export default {
  name: 'LaborConsumption',
  components: { Pagination },
  data() {
    return {
      dialogFull: false,
      isRoleEdit: [],
      requestParams: [
        { name: 'getDictByName', offset: 0, pagecount: 0, params: ['人工用量操作类型'] },
        { name: 'getCowclassListEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid') }}
      ],
      operationTypeList: [], // 操作类型
      feedNameList: [], // 饲料名称
      livestockList: [], // 牲畜类别

      table: {
        getdataListParm: {
          name: 'getFeeduseList',
          page: 1,
          offset: 1,
          pagecount: parseInt(Cookies.get('pageCount')),
          returntype: 'Map',
          parammaps: {
            inputDatetime: '',
            pastureid: Cookies.get('pastureid'),
            startTime: '',
            stopTime: '',
            usetype: '',
            feedid: '',
            cowclassid: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true
      },

      create: {
        pickerOptions1: {
          disabledDate(time) {
            return time.getTime() > Date.now()// 当天之前的时间可选
          }
        },
        dialogFormVisible: false,
        dialogStatus: '',
        createTemp: {
          pastureid: Cookies.get('pastureid'), usedate: parseTime(new Date(), '{y}-{m}-{d}'), feedid: '', feedname: '', cowclassid: '', cowclass: '', usetype: '', operateweight: '', repertoryweight: '', createemp: '', remark: '', price: '', operator: Cookies.get('employename')
        },
        getfeedNameParm: {
          name: 'getFeedstorageuse',
          offset: 0,
          pagecount: '',
          parammaps: { pastureid: Cookies.get('pastureid') }
        },
        rules: {
          usetype: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          usedate: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          feedname: [{ type: 'string', required: true, message: '必填', trigger: 'change' }],
          operateweight: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          cowclassid: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }]
        }
      },

      textMap: {
        create: '新增',
        update: '编辑'
      },
      requestParam: {},
      download: {
        getdataListParm: {
          name: 'getFeeduseList',
          page: 1,
          offset: 1,
          pagecount: 0,
          returntype: 'Map',
          parammaps: {
            inputDatetime: '',
            pastureid: Cookies.get('pastureid'),
            startTime: '',
            stopTime: '',
            usetype: '',
            feedid: '',
            cowclassid: ''
          }
        },
        list: []
      },
      isokDisable: false,
      rowStyle: { maxHeight: 30 + 'px', height: 30 + 'px' },
      cellStyle: { padding: 0 + 'px' },
      myHeight:document.documentElement.clientHeight - 85- 150 - 45
    }
  },
  computed: {
    // 设置请求头
    headers() {
      return {
        token: getToken()
      }
    },
    uploadData() {
      return {
        name: 'checkFeed,checkclassname,checkfeedusetype,insertFeeduseUpload,insertFeedstorageUseUpload',
        importParams: '出库日期,操作类型,牲畜类别,饲料名称,操作重量（kg）,备注,操作人',
        sheetname: 'Sheet1',
        // 登录牧场
        pastureid: Cookies.get('pastureid'),
        // 日期参数
        dateParams: '出库日期',
        // 必填参数
        requiredParams: '出库日期,操作类型,饲料名称,操作重量（kg）',
        // 为数值的参数
        numParams: '操作重量（kg）'
      }
    },
    // 设置上传地址
    uploadExcelUrl() {
      return process.env.VUE_APP_BASE_API + 'authdata/ImportExcel'
    }
  },
  created() {
    this.getList()
    this.getDownList()
    this.getButtons()
  },

  methods: {
    getButtons() {
      const Edit = 'SystemConsumption'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    getDownList() {
      GetDataByNames(this.requestParams).then(response => {
        this.operationTypeList = response.data.getDictByName.list
        this.livestockList = response.data.getCowclassListEnable.list
      })
    },
    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() - 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() - 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.table.getdataListParm.parammaps.startTime = parseTime(start, '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(stop, '{y}-{m}-{d}')
        this.$forceUpdate()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() + 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() + 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.table.getdataListParm.parammaps.startTime = parseTime(start, '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(stop, '{y}-{m}-{d}')
        this.$forceUpdate()
      }
    },
    getList() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
        } else {
          this.table.list = []
        }
        this.table.total = response.data.total
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },

    handleSearch() {
      console.log('点击了查询')
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.getList()
    },
    handleRefresh() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.inputDatetime = ''
      this.table.getdataListParm.parammaps.startTime = ''
      this.table.getdataListParm.parammaps.stopTime = ''
      this.table.getdataListParm.parammaps.feedid = ''
      this.table.getdataListParm.parammaps.cowclassid = ''
      this.table.getdataListParm.parammaps.ischarge = ''
      this.table.getdataListParm.parammaps.usetype = ''
      this.table.getdataListParm.parammaps.feedname = ''
      this.table.getdataListParm.parammaps.cowclassid = ''
      this.getList()
    },

    // 操作类型
    changeUsetype(item) {
      console.log(item)
      if (item == '损耗') {
        console.log(item)
        this.create.createTemp.cowclassid = '/'
        this.create.createTemp.cowclass = '/'
      } else {
        this.create.createTemp.cowclassid = ''
        this.create.createTemp.cowclass = ''
      }
    },
    tableFeedNameSearch(queryString, cb) {
      this.create.getfeedNameParm.parammaps['feedname'] = queryString
      GetDataByName(this.create.getfeedNameParm).then(response => {
        console.log('模糊查询搜索data', response.data.list)
        if (response.data.list == null) {
          cb([])
        } else {
          cb(response.data.list)
        }
      })
    },
    handleSelectTableFeedName(item) {
      this.table.getdataListParm.parammaps.feedid = item.feedid
    },
    // 饲料名称
    feedNameSearch(queryString, cb) {
      this.create.getfeedNameParm.parammaps['feedname'] = queryString
      GetDataByName(this.create.getfeedNameParm).then(response => {
        console.log('模糊查询搜索data', response.data.list)
        if (response.data.list == null) {
          cb([])
        } else {
          cb(response.data.list)
        }
      })
    },
    handleSelectFeedName(item) {
      console.log(item)
      this.create.createTemp.feedname = item.feedname
      this.create.createTemp.feedid = item.feedid
      this.create.createTemp.price = item.price
      this.create.createTemp.pcpde = item.pcpde
      this.create.createTemp.repertoryweight = item.stockweight
    },
    blurFeedName() {
      this.create.createTemp.feedname = ''
      this.create.createTemp.feedid = ''
      this.create.createTemp.price = ''
      this.create.createTemp.pcpde = ''
      this.create.createTemp.repertoryweight = ''
    },
    // 牲畜类别
    changeLivestock(item) {
      this.create.createTemp.cowclass = this.livestockList.find(obj => obj.id == item).classname
    },
    resetCreateTemp() {
      this.create.createTemp = {
        cowclassid1: '-1', pastureid: Cookies.get('pastureid'), usedate: parseTime(new Date(), '{y}-{m}-{d}'), feedid: '', feedname: '', cowclassid: '', cowclass: '', usetype: '', operateweight: '', repertoryweight: '', createemp: Cookies.get('employename'), remark: '', price: '', operator: Cookies.get('employename')
      }
    },
    handleCreate() {
      console.log('点击了新增')
      this.create.dialogStatus = 'create'
      this.dialogFull = false
      this.create.dialogFormVisible = true
      this.$nextTick(() => {
        this.resetCreateTemp()
        this.$refs.createTemp.resetFields()
      })
    },
    createData() {
      console.log('点击了新增保存')
      this.$refs['createTemp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          if (this.create.createTemp.usetype == '人工用料') {
            if (this.create.createTemp.cowclassid == '') {
              this.$message({ type: 'error', message: '请选择牲畜类别', duration: 2000 })
              return false
            }
          }
          const keepTwoNum = /^\d+(\.\d{1,2})?$/
          // 操作重量
          if (this.create.createTemp.operateweight == 0) {
            this.$message({ type: 'error', message: '操作重量请输入自然数并保留两位小数', duration: 2000 })
            return false
          } else {
            if (!keepTwoNum.test(parseFloat(this.create.createTemp.operateweight))) {
              this.$message({ type: 'error', message: '操作重量请输入自然数并保留两位小数', duration: 2000 })
              return false
            }
          }
          if (this.create.createTemp.cowclassid == '/' && this.create.createTemp.cowclass == '/') {
            this.create.createTemp.cowclassid = ''
            this.create.createTemp.cowclass = ''
          }
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertFeeduse', 'type': 'e', 'parammaps': {
            'pastureid': this.create.createTemp.pastureid,
            'usedate': this.create.createTemp.usedate,
            'feedid': this.create.createTemp.feedid,
            'feedname': this.create.createTemp.feedname,
            'cowclassid': this.create.createTemp.cowclassid,
            'cowclass': this.create.createTemp.cowclass,
            'usetype': this.create.createTemp.usetype,
            'operateweight': this.create.createTemp.operateweight,
            'repertoryweight': this.create.createTemp.repertoryweight,
            'createemp': this.create.createTemp.createemp,
            'remark': this.create.createTemp.remark,
            'price': this.create.createTemp.price
          }}
          this.requestParam.data[1] = { 'name': 'insertFeedstorageUse', 'type': 'e', 'parammaps': {
            'pastureid': this.create.createTemp.pastureid,
            'feedid': this.create.createTemp.feedid,
            'operateweight': this.create.createTemp.operateweight,
            'fname': this.create.createTemp.feedname,
            'pcpde': this.create.createTemp.pcpde,
            'price': this.create.createTemp.price
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            if (response.msg === 'fail') {
              this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '成功', type: 'success', duration: 2000 })
              this.create.dialogFormVisible = false
              this.getList()
            }
          })
        }
      })
    },
    handleUpdate(row) {
      this.$nextTick(() => {
        this.$refs.createTemp.resetFields()
      })
      this.dialogFull = false
      this.create.dialogStatus = 'update'
      this.create.dialogFormVisible = true
      if (row.cowclassid == -1) {
        row.cowclassid = ''
        row.cowclass = ''
      }
      this.create.createTemp = Object.assign({}, row)
    },
    updateData(){
      console.log('点击了编辑保存')
    },
    handleRowDelete(row) {
      console.log('点击了行内删除')
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {

      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    // 导出
    handleExport(item) {
      if (item == 1) {
        console.log('点击了导出模板')
        const requestParam = this.requestParam
        const url = process.env.VUE_APP_BASE_API + 'file/导入导出模板/库存管理/人工用量导入模板.xlsx' // 请求下载文件的地址
        console.log(url)
        axios({
          method: 'GET',
          url: url,
          data: requestParam,
          headers: { token: getToken(), optname: 'insertcustomdoc' },
          responseType: 'blob'
        }).then(res => {
          if (!res) return
          this.percentage = 99
          setTimeout(() => {
            this.isPercentage = false
          }, 2000)
          const blob = new Blob([res.data], {
            type: 'application/octet-stream;charset=utf-8'
          })
          const url = window.URL.createObjectURL(blob)
          const aLink = document.createElement('a')
          aLink.style.display = 'none'
          aLink.href = url
          const docname = '人工用量导入模板.xlsx'
          aLink.setAttribute('download', docname) // 下载的文件
          document.body.appendChild(aLink)
          aLink.click()
          document.body.removeChild(aLink)
          window.URL.revokeObjectURL(url)
        })
      } else {
        console.log('点击了导出数据')
        this.download.getdataListParm.parammaps = this.table.getdataListParm.parammaps
        if (this.download.getdataListParm.parammaps.inputDatetime !== '' && this.download.getdataListParm.parammaps.inputDatetime !== null) {
          this.download.getdataListParm.parammaps.startTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
          this.download.getdataListParm.parammaps.stopTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
        } else {
          this.download.getdataListParm.parammaps.inputDatetime = ''
          this.download.getdataListParm.parammaps.startTime = ''
          this.download.getdataListParm.parammaps.stopTime = ''
        }
        GetDataByName(this.download.getdataListParm).then(response => {
          if (response.data.list !== null) {
            this.download.list = response.data.list
          } else {
            this.download.list = []
          }
          var excelDatas = [
            {
              tHeader: ['出库日期', '操作类型', '牲畜类别', '饲料名称', '操作重量（kg）', '备注', '操作人'],
              filterVal: ['usedate', 'usetype', 'cowclass', 'feedname', 'operateweight', 'remark', 'createemp'],
              tableDatas: this.download.list,
              sheetName: 'Sheet1'
            }
          ]
          json2excel(excelDatas, '人工用量', true, 'xlsx')
        })
      }
    },

    beforeImport(file) {
      const isLt2M = file.size / 1024 / 1024 < 2
      if (!isLt2M) {
        this.$message.error('上传文件大小不能超过 2MB!')
      }
      return isLt2M
    },
    handleImportSuccess(res, file) {
      this.getList()
      if (res.msg === 'ok') {
        this.$message({ title: '成功', message: '导入成功:' + res.data.success + '条!', type: 'success', duration: 2000 })
        if (res.data.err_count > 0) {
          this.$notify({ title: '失败', message: '导入失败:' + res.data.err_count + '条!', type: 'danger', duration: 2000 })
           import('@/vendor/Export2Excel').then(excel => {
             const list1 = res.data.result
             const tHeader = [
               '出库日期', '操作类型', '牲畜类别', '饲料名称', '操作重量（kg）', '备注', '操作人', '错误信息'
             ]
             const filterVal = [
               '出库日期', '操作类型', '牲畜类别', '饲料名称', '操作重量（kg）', '备注', '操作人', 'error_msg'
             ]
             const data1 = this.formatJson(filterVal, list1)
             excel.export_json_to_excel({ header: tHeader, data: data1, filename: '人工用量导入报错信息', autoWidth: true, bookType: 'xlsx' })
           })
        }
      } else {
        this.$notify({ title: '失败', message: '上传失败', type: 'danger', duration: 2000 })
      }
    },
    formatJson(filterVal, jsonData) {
      return jsonData.map(v =>
        filterVal.map(j => {
          if (j === 'timestamp') {
            return parseTime(v[j])
          } else {
            return v[j]
          }
        })
      )
    }
  }
}
</script>
 <style lang="scss">
   .typeSelect span .el-popover__reference .el-input--suffix {
       .el-input__inner{
         height:40px !important;
       }
     }
 </style>
